'
' This source code is provided 'as is' and any express or implied warranties, including,
' but not limited to, the implied warranties of merchantability and fitness for a particular
' purpose are disclaimed.
'
' In no event shall the author, Crownhill or contributers be liable for any direct, indirect, incidental,
' special, exemplary, or consequential damages (including, but not limited to,  procurement of substitute
' goods or services; loss of use, data, or profits;  or business interruption) however caused and on any
' theory of liability, whether in contract, strict liability, or tort (including negligence or otherwise)
' arising in any way out of the use of this source code, even if advised of the possibility of such damage.
'
' Any views and conclusions contained in the source code and any documentation are those of the author's
' and should not be interpreted as representing official policies,
' either expressed or implied, of Crownhill Associates Ltd.
'
' Interface to an I2C eeprom using software I2C routines written in Proton BASIC
'
    'Include "Proton_4.inc"              ' Compile for a 16F877 running at 4MHz
    'Include "Amicus18.inc"
    Include "Amicus24H.inc"
'
' Setup the pins for SDA and SCL (These must be declared before the Include file)
'    
    $define I2C_SDA_Pin PORTB.4         ' The pin used for SDA
    $define I2C_SCL_Pin PORTB.3         ' The pin used for SCL

    Include "Software_I2C.inc"          ' Load the software I2C routines into the program
'
' Create some variables for use by the demo
'  
    Dim MyLoop As Byte 
    Dim MyArray[10] As Byte
    
'----------------------------------------------------------------------------------------------
Main:   
'     
' Transmit bytes to the I2C bus 
'
    I2C_Start()                         ' Send a Start condition 
    I2C_WriteByte($A0)                  ' Target an eeprom, and send a Write command 
    I2C_WriteByte(0)                    ' Send the High byte of the address 
    I2C_WriteByte(0)                    ' Send the Low byte of the address 
    For MyLoop = 48 To 57               ' Create a loop containing ASCII 0 to 9 
        I2C_WriteByte(MyLoop)           ' Send the value of MyLoop to the eeprom 
    Next                                ' Close the loop 
    I2C_Stop()                          ' Send a Stop condition 
    DelayMS 5                           ' Wait for the data to be entered into eeprom matrix 
'
' Receive bytes from the I2C bus 
'
    I2C_Start()                         ' Send a Start condition 
    I2C_WriteByte($A0)                  ' Target an eeprom and send a Write command 
    I2C_WriteByte(0)                    ' Send the High Byte of the address 
    I2C_WriteByte(0)                    ' Send the Low Byte of the address 
    I2C_Restart()                       ' Send a Restart condition 
    I2C_WriteByte($A1)                  ' Target an eeprom and send a Read command 
    For MyLoop = 0 To 9                 ' Create a loop 
        MyArray[MyLoop] = I2C_ReadByte()' Load an array with bytes received 
        If MyLoop = 9 Then              ' \ 
            I2C_Stop()                  ' |
        Else                            ' | Ack or Stop?
            I2C_Ack()                   ' |
        EndIf                           ' /
    Next                                ' Close the loop 
    HRSOut Str MyArray, 13              ' Transmit the Array as an ASCII String 
    Stop 
        
